mysite/enquetes/urls.py
from django.urls import path
from . import views

app_name = 'enquetes'
urlpatterns = [
    path('', views.IndexView.as_view(), name='index'),
    path(
        'enquete/<int:pk>/',
        views.DetalhesView.as_view(), name='detalhes'
    ),
    path(
        'enquete/<int:pk>/votacao/',
        views.VotacaoView.as_view(), name='votacao'
    ),
    path(
        'enquete/<int:pk>/resultado/',
        views.ResultadoView.as_view(), name='resultado'
    ),
    path('sobre/', views.sobre, name='sobre'),
]

mysite/mysite/urls.py
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('enquetes.urls')),
    path('prova/', include('prova1.urls')),
    path('vagasifrn/', include('vagasifrn.urls')),
    path('accounts/', include('django.contrib.auth.urls')),
]

mysite/enquetes/models.py
import datetime
from django.db import models
from django.utils import timezone

class Pergunta(models.Model):
    texto = models.CharField(max_length=150)
    data_pub = models.DateTimeField('Data de publicação')
    ativo = models.BooleanField(default=True)
    def __str__(self):
        return '{} ({})'.format(self.texto, self.id)
    def publicada_recentemente(self):
        agora = timezone.now()
        return ((self.data_pub <= agora) and
            (self.data_pub >= agora - datetime.timedelta(hours=24)))
    publicada_recentemente.admin_order_field = 'data_pub'
    publicada_recentemente.boolean = True
    publicada_recentemente.short_description = 'Recente?'
    def eh_valida(self):
        if self.alternativa_set.count() > 1:
            return True
        return False

class Alternativa(models.Model):
    texto = models.CharField(max_length=80)
    quant_votos = models.IntegerField('Quantidade de votos', default=0)
    pergunta = models.ForeignKey(Pergunta, on_delete=models.CASCADE)
    ativo = models.BooleanField(default=True)
    def __str__(self):
        return '{} - {} ({})'.format(self.pergunta.texto, self.texto, self.id)

mysite/prova1/models.py
from django.db import models

class Aluno(models.Model):
    nome = models.CharField(max_length=40)
    matricula = models.CharField(max_length=15)
    def __str__(self):
        return '({}) {}'.format(self.id, self.nome)

class Prova(models.Model):
    nome = models.CharField(max_length=30)
    def soma_pontos(self):
        soma = 0
        for q in self.questao_set.all():
            soma += q.pontos
        return soma
    def __str__(self):
        return '({}) {}'.format(self.id, self.nome)

class Questao(models.Model):
    ordem = models.IntegerField()
    enunciado = models.CharField(max_length=300)
    pontos = models.IntegerField(default=10)
    prova = models.ForeignKey(Prova, on_delete=models.CASCADE)
    def __str__(self):
        return '({}) {}'.format(self.id, self.enunciado)

class Alternativa(models.Model):
    texto = models.CharField(max_length=300)
    correta = models.BooleanField(default=False)
    questao = models.ForeignKey(Questao, on_delete=models.CASCADE)
    def __str__(self):
        return '({}) questão: {} = {}'.format(
            self.id, self.questao.enunciado, self.texto
        )

class ProvaRealizada(models.Model):
    data = models.DateTimeField()
    aluno = models.ForeignKey(Aluno, on_delete=models.CASCADE)
    prova = models.ForeignKey(Prova, on_delete=models.CASCADE)
    def pontos_obtidos(self):
        total = 0
        for resp in self.resposta_set.all():
            total += resp.pontos()
        return total
    def __str__(self):
        return '{} - por: {}'.format(self.prova, self.aluno)

class Resposta(models.Model):
    prova = models.ForeignKey(ProvaRealizada, on_delete=models.CASCADE)
    alternativa = models.ForeignKey(Alternativa, on_delete=models.CASCADE)
    def pontos(self):
        if self.alternativa.correta:
            return self.alternativa.questao.pontos
        return 0
    def __str__(self):
        return '({}) resposta: {} - questão: {}'.format(
            self.id, self.alternativa.texto, self.alternativa.questao
        )

mysite/enquetes/views.py
from django.shortcuts import render, get_object_or_404
from django.http import Http404, HttpResponse, HttpResponseRedirect
from django.views import View
from django.urls import reverse
from django.utils import timezone
from .models import Pergunta, Alternativa

class IndexView(View):
    def get(self, request, *args, **kwargs):
        lista_perguntas = Pergunta.objects.filter(
            data_pub__lte = timezone.now()
        ).order_by('-data_pub')
        contexto = {'pergunta_list': lista_perguntas}
        return render(request, 'enquetes/index.html', contexto)

class DetalhesView(View):
    def get(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk=kwargs['pk'])
        if pergunta.data_pub > timezone.now():
            raise Http404('Nenhuma enquete satisfaz o critério informado')
        return render(
            request, 'enquetes/detalhes.html', {'pergunta':pergunta}
        )

class ResultadoView(View):
    def get(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk=kwargs['pk'])
        if pergunta.data_pub > timezone.now():
            raise Http404('Nenhuma enquete satisfaz o critério informado')
        return render(request, 'enquetes/resultado.html', {'pergunta':pergunta})

class VotacaoView(View):
    def post(self, request, *args, **kwargs):
        pergunta = get_object_or_404(Pergunta, pk=kwargs['pk'])
        try:
            alt_id = request.POST['alt_id']
            alt_escolhida = pergunta.alternativa_set.get(pk=alt_id)
        except (KeyError, Alternativa.DoesNotExist):
            return self.erro_no_form(
                request, pergunta,
                'Você percisa selecionar uma alternativa válida!'
            )
        else:
            alt_escolhida.quant_votos += 1
            alt_escolhida.save()
            return HttpResponseRedirect(
                reverse('enquetes:resultado', args=(pergunta.id,))
            )
    def erro_no_form(self, request, pergunta, erro):
        contexto = {
            'pergunta': pergunta,
            'error': erro
        }
        return render(request, 'enquetes/detalhes.html', contexto)

def sobre(request):
    return HttpResponse('&copy; DSWeb/TADS/CNAT/IFRN, 2023.')

"""
1ª versão da visão de INDEX
def index(request):
    lista_perguntas = Pergunta.objects.order_by('data_pub')
    resposta = '<br/> '.join([p.texto for p in lista_perguntas])
    return HttpResponse('<h3>%s</h3>'%resposta)

from django.template import loader
2ª versão da visão de INDEX
def index(request):
    lista_perguntas = Pergunta.objects.order_by('-data_pub')
    template = loader.get_template('enquetes/index.html')
    contexto = {'lista_perguntas': lista_perguntas}
    return HttpResponse(template.render(contexto, request))

3ª versão da visão de INDEX
def index(request):
    lista_perguntas = Pergunta.objects.order_by('-data_pub')
    contexto = {'lista_perguntas': lista_perguntas}
    return render(request, 'enquetes/index.html', contexto)

from django.views import generic
4ª versão da visão de INDEX
class IndexView(generic.ListView):
    template_name = 'enquetes/index.html'
    def get_queryset(self):
        return Pergunta.objects.order_by('data_pub')

from django.http import HttpResponse, Http404
1ª versão da visão de DETALHES
def detalhes(request, pergunta_id):
    try:
        pergunta = Pergunta.objects.get(id=pergunta_id)
    except Pergunta.DoesNotExist:
        raise Http404('Nenhuma enquete satisfaz esse critério.')
    return render(request, 'enquetes/detalhes.html', {'pergunta':pergunta})

from django.shortcuts import render, get_object_or_404
2ª versão da visão de DETALHES
def detalhes(request, pergunta_id):
    pergunta = get_object_or_404(Pergunta, pk=pergunta_id)
    return render(request, 'enquetes/detalhes.html', {'pergunta':pergunta})

from django.views import View, generic
3ª versão da visão de DETALHES
class DetalhesView(generic.DetailView):
    model = Pergunta

from django.shortcuts import render, get_object_or_404
1ª versão da visão de RESULTADO
def resultado(request, pergunta_id):
    pergunta = get_object_or_404(Pergunta, pk=pergunta_id)
    return render(request, 'enquetes/resultado.html', {'pergunta':pergunta})

from django.views import View, generic
2ª versão da visão ed RESULTADO
class ResultadoView(generic.DetailView):
    model = Pergunta
    template_name = 'enquetes/resultado.html'

"""

mysite/enquetes/templates/enquetes/base.html
{% load static %}
<html>
    <head>
        <title>Enquetes App</title>
        <link rel="stylesheet" type="text/css"
              href="{% static 'enquetes/css/style.css' %}"/>
    </head>
    <body>
        <h1>Aplicação de Enquetes - DSWeb 2023.2</h1>
        {% block subtitulo %}
        {% endblock %}
        {% block principal %}
        {% endblock %}
        <hr/>
        {% block menu %}
        <a href="{% url 'enquetes:index' %}">Início</a>
            {% block novo_menu %}
            {% endblock %}
        {% endblock %}
    </body>
</html>

mysite/enquetes/templates/enquetes/detalhes.html
{% extends 'enquetes/base.html' %}
{% load humanize %}
{% block subtitulo %}
    <h3>#{{ pergunta.id }} {{ pergunta.texto }}</h3>
{% endblock %}

{% block principal %}
    <p>Data de publicação: {{ pergunta.data_pub | naturaltime }}</p>
    {% if error %}
        <h3>ERRO: {{ error }}</h3>
    {% endif %}
    <form action="{% url 'enquetes:votacao' pergunta.id %}" method="post">
        {% csrf_token %}
        <ul>
            {% for alt in pergunta.alternativa_set.all %}
                <li>
                    <input id="alt{{ forloop.counter }}" type="radio"
                           name="alt_id" value="{{ alt.id }}"/>
                    <label for="alt{{ forloop.counter }}">
                        {{ alt.texto }}
                    </label>
                </li>
            {% endfor %}
        </ul>
        <input type="submit" value="Registre o seu voto">
    </form>
{% endblock %}

mysite/enquetes/templates/enquetes/index.html
{% extends 'enquetes/base.html' %}
{% load static %}

{% block subtitulo %}
    <img width="120" src="{% static 'enquetes/img/enquete.jpg' %}"/>
{% endblock %}

{% block principal %}
    {% if pergunta_list %}
        <ul>
            {% for pergunta in pergunta_list %}
                <li><a href="{% url 'enquetes:detalhes' pergunta.id %}">
                    {{ pergunta.texto }}</a>&nbsp;
                    (<a href="{% url 'enquetes:resultado' pergunta.id %}">parcial</a>)
                </li>
            {% endfor %}
        </ul>
    {% else %}
        <h3>Nenhuma enquete cadastrada até o momento!</h3>
    {% endif %}
{% endblock %}

mysite/enquetes/templates/enquetes/resultado.html
{% extends 'enquetes/base.html' %}

{% block subtitulo %}
    <h3>Resultado Parcial</h3>
{% endblock %}

{% block principal%}
    <h3>#{{ pergunta.id }} {{ pergunta.texto }}</h3>
    <p>Data de publicação: {{ pergunta.data_pub | date:"d/m/Y" }} às
    {{ pergunta.data_pub | time:"H:i" }}hs</p>
    <ul>
        {% for alt in pergunta.alternativa_set.all %}
            <li>
                {{ alt.texto }} == {{ alt.quant_votos }}
                voto{{ alt.quant_votos | pluralize }}
            </li>
        {% endfor %}
    </ul>
{% endblock %}

{% block novo_menu %}
    | <a href="{% url 'enquetes:detalhes' pergunta.id %}">Votar novamente</a>
{% endblock %}